<template>
  <view class="container">
    <u-sticky offsetTop="8rpx" customNavHeight="8rpx">
         <view class="search-view">
          <u--input v-model="queryParams.name" border="false" placeholder="请输入投资账户名称" class="search-input"
          @blur="searchBlur" suffixIcon="search" suffixIconStyle="color: #909399">
        </u--input>
        <u-icon name="plus-circle-fill" color="#666666" size="28" style="margin-left:10px" label="新增"
        labelPos="left" labelSize="32rpx" labelColor="#666666" @click="handleAdd()"></u-icon>
       </view>
       </u-sticky>
    <u-sticky offsetTop="8rpx" customNavHeight="8rpx">
      <view class="search-view">
        <u-input v-model="queryParams.time" border="false" type="select" readonly placeholder="请选择交易时间" suffixIcon="calendar"
          suffixIconStyle="color: #909399" class="search-input">
          </u-input>
        <u-icon :name="filterPanel ? 'arrow-up-fill' : 'arrow-down-fill'" color="#666666" size="28" label="筛选"
          labelPos="left" labelSize="32rpx" labelColor="#666666" @click="filterPanel = !filterPanel"></u-icon>

        <u-transition :show="filterPanel" mode="fade">
          <view class="filter-panel" :style="{ height: `${windowHeight - 42}px` }">
            <view class="filter-panel-content">
              <view class="filter-title">交易类型</view>
              <view class="state-list">
                <view v-for="item in dealTypeList" :key="item.id" class="state-item"
                  :class="item.selected ? 'active' : ''" @click="selectDealType(item)">{{ item.dictLabel }}</view>
              </view>
              <view class="select-header">交易时间</view>
            <view class="selcet-content" style="padding: 0 24rpx">
              <u-input
                :disabled="true"
                :disabledColor="'#fff'"
                class="dateInput"
                border="surround"
                v-model="queryParams.startTime"
                placeholder="请选择开始时间"
              >
                <template v-slot:suffix>
                  <u-icon name="calendar" @click="openOrCloseDate(true)"></u-icon>
                </template>
              </u-input>
              <u-input
                :disabled="true"
                :disabledColor="'#fff'"
                class="dateInput"
                border="surround"
                v-model="queryParams.endTime"
                placeholder="请选择结束时间"
              >
                <template v-slot:suffix>
                  <u-icon name="calendar" @click="openOrCloseDate(false)"></u-icon>
                </template>
              </u-input>
            </view>
            </view>
            <view class="btn-box">
              <u-button text="重置" style="margin-right:20rpx" @click="resetQuery()"></u-button>
              <u-button type="primary" text="确定" @click="searchSubmit()"></u-button>
            </view>
            <u-datetime-picker
              :closeOnClickOverlay="true"
              :show="timeShow"
              v-model="time"
              mode="date"
              @close="openOrCloseDate"
              @cancel="openOrCloseDate"
              @confirm="confirm"
            ></u-datetime-picker>
          </view>
        </u-transition>
      </view>
    </u-sticky>
    <u-list @scrolltolower="loadmore" :spaceHeight="116" lowerThreshold="100">
      <u-list-item v-for="(item, index) in listData" :key="index">
        <view class="list-item">
          <view class="item-header" @click="enterDetails(item)">
            <u--text suffixIcon="arrow-right" lines="1" iconStyle="font-size: 18px; color: #333333; font-weight:bold"
              :text="item.accountName+dictStr(item.dealType, dealTypeList) +'：'+item.amount" size="30rpx" color="#333333" :bold="true"></u--text>
          </view>
          <view class="item-row">
            <text class="row-label">交易类型：</text>
            <text class="row-value">{{ dictStr(item.dealType, dealTypeList) }}</text>
          </view>
          <view class="item-row">
            <text class="row-label">交易时间：</text>
            <text class="row-value">{{ item.createTime }}</text>
          </view>
          <view class="item-row">
            <text class="row-label">交易金额：</text>
            <text class="row-value">{{ item.amount }}</text>
          </view>
          <view class="item-row">
            <text class="row-label">当前余额：</text>
            <text class="row-value">{{ item.currentBalance }}</text>
          </view>

          <view class="item-row">
            <text class="row-label">备注：</text>
            <text class="row-value">{{ item.remark }}</text>
          </view>
          <view class="operate" >
            <!-- <view class="btn filling" @click="enterDetails(item)">查看</view> -->
            <!-- <view class="btn filling" @click="handleEdit(item)">修改</view> -->
            <view class="btn filling" @click="handleDelete(item)">删除</view>
          </view>
        </view>
      </u-list-item>
      <view>
      </view>
      <u-loadmore :status="status" loadingIcon="semicircle" height="88" fontSize="32rpx" @loadmore="loadmore" />
    </u-list>
    <u-picker itemHeight="88" :show="settingPickShow" :columns="settingColumns" keyName="settingName"
      @confirm="settingConfirm" @cancel="settingCancel"></u-picker>
  </view>
</template>

<script setup>
import {
  listAccountDealRecord,
  delAccountDealRecord,
} from '@/api/invest/accountDealRecord'
import { getDicts } from '@/api/system/dict/data.js'
import { timeHandler } from '@/utils/common.ts'
import {onLoad,onShow} from "@dcloudio/uni-app";
import dayjs from 'dayjs'
    // 计算属性与监听属性是在vue中而非uniap中 需要注意！！！
import {reactive ,toRefs,ref,computed }from "vue";
const pageNum = ref(1)
const listData = ref([])
const isShow = ref(false)
const status = ref('loadmore')
const accountTypeList = ref([])
const dealTypeList = ref([])
const dealCategoryList = ref([])
const settingPickShow = ref(false)
const settingColumns = ref([])
const timeShow= ref(false)
const  flag= ref(true)
const time =ref( Number(new Date()))
const data = reactive({
  filterPanel: false,
  queryParams: {
    name: null,
    type: '5',
    time: '',
    dealCategory: '2',
    accountId: null,
    dealType: null
   } 
})
const { filterPanel, queryParams} = toRefs(data)
const windowHeight = computed(() => {
			uni.getSystemInfoSync().windowHeight - 50
		})	
onLoad(() => {
    getDict()
    getList()
  });

 onShow(() => {
    if (isShow.value) {
      getList()
      isShow.value = false
    }
  });
  function  openOrCloseDate(data) {
      timeShow.value = !timeShow.value
      flag.value = data
    }
function loadmore() {
      pageNum.value += 1
      if (status.value == 'loadmore') {
        getList()
      }
    }
function getList() {
      status.value = 'loading'
      listAccountDealRecord({ pageSize: 10, pageNum: pageNum.value, ...queryParams.value }).then(res => {
        listData.value = listData.value.concat(res.rows)
        if (listData.value.length < res.total) {
          status.value = 'loadmore'
        } else {
          status.value = 'nomore'
        }
      }).catch(() => {
        status.value = 'nomore'
      })
    }
    function confirm(e) {
      const date = timeHandler(new Date(e.value), '-', ':')
            let formatValue = 'YYYY-MM-DD'
            dayjs(date).format(formatValue)
      if (flag.value) {
        queryParams.value.startTime =  dayjs(date).format(formatValue)
      } else {
        queryParams.value.endTime =  dayjs(date).format(formatValue)
      }
      timeShow.value = false
    }
function   getDict() {
       // 交易类型
       getDicts('profit_loss').then(res => {
        dealTypeList.value = res.data
      })
    }
function settingConfirm(e) {
      queryParams.value.settingId = e.value[0].settingId
      queryParams.value.settingName = e.value[0].settingName
      settingPickShow.value = false
    }
function settingCancel() {
      settingPickShow.value = false
    }
function dictStr(val, arr) {
      let str = ''
      arr.map(item => {
        if (item.dictValue === val) {
          str = item.dictLabel
        }
      })
      return str
    }
function selectAccountType(item) {
      queryParams.value.type = item.dictValue
      accountTypeList.value.map(ele => {
        if (ele.dictValue == item.dictValue) {
          ele.selected = true
          Reflect.set(ele, 'selected', true)
        } else {
          Reflect.set(ele, 'selected', false)
        }
      })
    }
    function selectDealType(item) {
      queryParams.value.dealType = item.dictValue
      dealTypeList.value.map(ele => {
        if (ele.dictValue == item.dictValue) {
          ele.selected = true
          Reflect.set(ele, 'selected', true)
        } else {
          Reflect.set(ele, 'selected', false)
        }
      })
    }
    function selectDealCategory(item) {
      queryParams.value.dealCategory = item.dictValue
      dealCategoryList.value.map(ele => {
        if (ele.dictValue == item.dictValue) {
          ele.selected = true
          Reflect.set(ele, 'selected', true)
        } else {
          Reflect.set(ele, 'selected', false)
        }
      })
    }
    function searchSubmit() {
      if(queryParams.value.startTime!=''&&queryParams.value.endTime!=''){
        queryParams.value.time = queryParams.value.startTime+'-'+queryParams.value.endTime 
      } 
      pageNum.value = 1
      listData.value = []
      getList()
      filterPanel.value = false
    }
    function searchBlur() {
      pageNum.value = 1
      listData.value = []
      getList()
    }
    function resetQuery() {
       queryParams.value.time = ''
        queryParams.value.name = ''
        queryParams.value.type = '5'
        queryParams.value.dealType = ''
        queryParams.value.startTime = ''
        queryParams.value.endTime = ''
        queryParams.value.dealCategory = '2'
      accountTypeList.value.map(ele => {
        Reflect.set(ele, 'selected', false)
      })
      dealTypeList.value.map(ele => {
        Reflect.set(ele, 'selected', false)
      })
      dealCategoryList.value.map(ele => {
        Reflect.set(ele, 'selected', false)
      })
    }
    function enterDetails(item) {
      uni.navigateTo({ url: `/pages/work/accounts/investAccountDeal/details?id=${item.id}` })
    }
    function handleEdit(item) {
      uni.navigateTo({ url: `/pages/work/accounts/investAccountDeal/addEdit?id=${item.id}` })
      isShow.value = true
    }
    function handleAdd() {
      uni.navigateTo({ url: `/pages/work/accounts/investAccountDeal/addEdit` })
      isShow.value = true
    }
    function handleDelete(item) {
      uni.showModal({
        	title: '提示',
        	content: '你确定要删除吗',
        	success: function (res) {
        		if (res.confirm) {
        		  delAccountDealRecord(item.id)
              uni.navigateTo({ url: `/pages/work/accounts/investAccountDeal/list` })
        		} else if (res.cancel) {
        			console.log('取消');
        		}
        	}
        });
    }
	
</script>

<style lang="scss" scoped>
.btnAdd {
      width: 146rpx;
      height: 56rpx;
      line-height: 56rpx;
      border-radius: 8rpx;
      display:float;
      text-align: center;
    }

.search-view {
  padding: 12rpx 32rpx;
  background-color: #ffffff;
  display: flex;
  justify-content: space-between;
  align-items: center;
  position: relative;

  .search-input {
    background: #F5F5F5;
    color: #333333;
    margin-right: 36rpx;
  }

  .filter-panel {
    width: 100%;
    position: absolute;
    left: 0;
    top: 96rpx;
    background-color: rgba(0, 0, 0, 0.5);

    .filter-panel-content {
      background-color: #ffff;
      padding: 0 30rpx 30rpx;

      .filter-title {
        color: #000000;
        font-size: 30rpx;
        font-weight: 500;
        padding: 30rpx 0;
      }

      .state-list {
        display: flex;
        flex-wrap: wrap;
        justify-content: flex-start;

        .state-item {
          width: 210rpx;
          height: 72rpx;
          border: 1rpx solid rgba(0, 0, 0, 0.25);
          border-radius: 72rpx;
          text-align: center;
          line-height: 72rpx;
          margin: 0 20rpx 20rpx 0;
          font-size: 28rpx;
          color: #000000;
        }

        .active {
          background-color: rgba(222, 241, 255, 1);
          border: 1rpx solid rgba(22, 119, 255, 1);
        }
      }
    }

    .btn-box {
      display: flex;
      padding: 24rpx 30rpx;
      background-color: #fff;
      box-shadow: 0rpx -10rpx 20rpx #EEEEEE;
    }
  }
}

.list-item {
  margin: 0 24rpx 24rpx;
  padding: 32rpx;
  background-color: #fff;

  .item-header {
    display: flex;
    justify-content: space-between;
    align-items: center;
    padding-bottom: 16rpx;

    .status {
      .status-item {
        width: 120rpx;
        height: 44rpx;
        text-align: center;
        line-height: 44rpx;
        border-radius: 4rpx;
        font-size: 24rpx;
      }

      .status1 {
        background: #F0F0F0;
        color: #8C8C8C;
      }

      .status2 {
        background: rgba(38, 129, 255, 0.2);
        color: #2681FF;
      }

      .status3 {
        background: #F7F7F7;
        color: #2681FF;
      }

      .status4 {
        background: rgba(255, 85, 51, 0.2);
        color: #FF5533;
      }

      .status5 {
        background: #F7F7F7;
        color: rgba(0, 0, 0, 0.85);
      }

      .status7 {
        background: rgba(255, 129, 51, 0.2);
        color: #FF8133;
      }

      .status8 {
        background: rgba(65, 217, 165, 0.2);
        color: #41D9A5;
      }
    }
  }

  .item-row {
    padding: 16rpx 0;

    .row-label {
      color: rgba(0, 0, 0, 0.55);
    }

    .row-value {
      color: rgba(0, 0, 0, 0.85)
    }
  }

  .operate {
    display: flex;
    justify-content: flex-end;

    .btn {
      width: 146rpx;
      height: 56rpx;
      line-height: 56rpx;
      border-radius: 8rpx;
      margin-left: 5rpx;
      text-align: center;
    }

    .circulation {
      background: rgba(0, 0, 0, 0.04);
      margin-right: 24rpx;
      color: rgba(0, 0, 0, 0.85);
    }

    .filling {
      background: #2681FF;
      border-radius: 8rpx;
      color: #FFFFFF;
    }
  }
}
</style>